# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *

ASEGSTATS2TABLE_METADATA = Metadata(
    id="913ffe3689796073b891a61e20a937aa44732063.boutiques",
    name="asegstats2table",
    package="freesurfer",
    container_image_tag="freesurfer/freesurfer:7.4.1",
)


Asegstats2tableParameters = typing.TypedDict('Asegstats2tableParameters', {
    "__STYXTYPE__": typing.Literal["asegstats2table"],
    "subjects": typing.NotRequired[list[str] | None],
    "inputs": typing.NotRequired[list[str] | None],
    "tablefile": str,
    "subjectsfile": typing.NotRequired[InputPathType | None],
    "qdec": typing.NotRequired[InputPathType | None],
    "qdec_long": typing.NotRequired[InputPathType | None],
    "fsgd": typing.NotRequired[InputPathType | None],
    "maxsegno": typing.NotRequired[list[str] | None],
    "segids_from_file": typing.NotRequired[InputPathType | None],
    "segno_include": typing.NotRequired[list[str] | None],
    "segno_exclude": typing.NotRequired[list[str] | None],
    "measure": typing.NotRequired[str | None],
    "delimiter": typing.NotRequired[str | None],
    "statsfile": typing.NotRequired[str | None],
    "subdir": typing.NotRequired[str | None],
    "scale": typing.NotRequired[float | None],
    "write_etiv": bool,
    "debug": bool,
    "transpose_flag": bool,
    "common_segs_flag": bool,
    "all_segs_flag": bool,
    "no_vol_extras_flag": bool,
    "skip_missing_flag": bool,
    "replace53_flag": bool,
})


def dyn_cargs(
    t: str,
) -> typing.Any:
    """
    Get build cargs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build cargs function.
    """
    return {
        "asegstats2table": asegstats2table_cargs,
    }.get(t)


def dyn_outputs(
    t: str,
) -> typing.Any:
    """
    Get build outputs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build outputs function.
    """
    return {
        "asegstats2table": asegstats2table_outputs,
    }.get(t)


class Asegstats2tableOutputs(typing.NamedTuple):
    """
    Output object returned when calling `asegstats2table(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""
    output_table: OutputPathType
    """The resulting table file with segmentation data."""


def asegstats2table_params(
    tablefile: str,
    subjects: list[str] | None = None,
    inputs: list[str] | None = None,
    subjectsfile: InputPathType | None = None,
    qdec: InputPathType | None = None,
    qdec_long: InputPathType | None = None,
    fsgd: InputPathType | None = None,
    maxsegno: list[str] | None = None,
    segids_from_file: InputPathType | None = None,
    segno_include: list[str] | None = None,
    segno_exclude: list[str] | None = None,
    measure: str | None = None,
    delimiter: str | None = None,
    statsfile: str | None = None,
    subdir: str | None = None,
    scale: float | None = None,
    write_etiv: bool = False,
    debug: bool = False,
    transpose_flag: bool = False,
    common_segs_flag: bool = False,
    all_segs_flag: bool = False,
    no_vol_extras_flag: bool = False,
    skip_missing_flag: bool = False,
    replace53_flag: bool = False,
) -> Asegstats2tableParameters:
    """
    Build parameters.
    
    Args:
        tablefile: The output table file.
        subjects: List of subjects.
        inputs: List of input stat files.
        subjectsfile: Name of the file which has the list of subjects (one\
            subject per line).
        qdec: Name of the qdec table which has the column of subjects ids\
            (fsid).
        qdec_long: Name of the longitudinal qdec table with column of tp ids\
            (fsid) and subject templates (fsid-base).
        fsgd: Name of the FSGD file to extract subjects from.
        maxsegno: Specify the maximum segmentation number.
        segids_from_file: Output only the segmentations present in the\
            specified file.
        segno_include: Include only the specified segmentation IDs.
        segno_exclude: Exclude the specified segmentation IDs.
        measure: Measure to report: default is volume (alternative: mean, std).
        delimiter: Delimiter between measures in the table. Default is tab\
            (alternative: comma, space, semicolon).
        statsfile: Use specified stats file instead of 'aseg.stats'.
        subdir: Use specified subdir instead of 'stats/'.
        scale: Scale factor for all values written to output file. Default is\
            1.
        write_etiv: Report volume as percent estimated total intracranial\
            volume.
        debug: Increase verbosity for debugging purposes.
        transpose_flag: Transpose the table: subjects in columns and\
            segmentations in rows.
        common_segs_flag: Output only the segmentations common to all stats\
            files.
        all_segs_flag: Output all segmentations in the stats files given.
        no_vol_extras_flag: Do not include global volume measures like\
            BrainSegVol.
        skip_missing_flag: Skip subjects that do not have a stats file.
        replace53_flag: Replace 5.3 structure names with later names.
    Returns:
        Parameter dictionary
    """
    params = {
        "__STYXTYPE__": "asegstats2table",
        "tablefile": tablefile,
        "write_etiv": write_etiv,
        "debug": debug,
        "transpose_flag": transpose_flag,
        "common_segs_flag": common_segs_flag,
        "all_segs_flag": all_segs_flag,
        "no_vol_extras_flag": no_vol_extras_flag,
        "skip_missing_flag": skip_missing_flag,
        "replace53_flag": replace53_flag,
    }
    if subjects is not None:
        params["subjects"] = subjects
    if inputs is not None:
        params["inputs"] = inputs
    if subjectsfile is not None:
        params["subjectsfile"] = subjectsfile
    if qdec is not None:
        params["qdec"] = qdec
    if qdec_long is not None:
        params["qdec_long"] = qdec_long
    if fsgd is not None:
        params["fsgd"] = fsgd
    if maxsegno is not None:
        params["maxsegno"] = maxsegno
    if segids_from_file is not None:
        params["segids_from_file"] = segids_from_file
    if segno_include is not None:
        params["segno_include"] = segno_include
    if segno_exclude is not None:
        params["segno_exclude"] = segno_exclude
    if measure is not None:
        params["measure"] = measure
    if delimiter is not None:
        params["delimiter"] = delimiter
    if statsfile is not None:
        params["statsfile"] = statsfile
    if subdir is not None:
        params["subdir"] = subdir
    if scale is not None:
        params["scale"] = scale
    return params


def asegstats2table_cargs(
    params: Asegstats2tableParameters,
    execution: Execution,
) -> list[str]:
    """
    Build command-line arguments from parameters.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Command-line arguments.
    """
    cargs = []
    cargs.append("asegstats2table")
    if params.get("subjects") is not None:
        cargs.extend([
            "--subjects",
            *params.get("subjects")
        ])
    if params.get("inputs") is not None:
        cargs.extend([
            "--inputs",
            *params.get("inputs")
        ])
    cargs.extend([
        "--tablefile",
        params.get("tablefile")
    ])
    if params.get("subjectsfile") is not None:
        cargs.extend([
            "--subjectsfile",
            execution.input_file(params.get("subjectsfile"))
        ])
    if params.get("qdec") is not None:
        cargs.extend([
            "--qdec",
            execution.input_file(params.get("qdec"))
        ])
    if params.get("qdec_long") is not None:
        cargs.extend([
            "--qdec-long",
            execution.input_file(params.get("qdec_long"))
        ])
    if params.get("fsgd") is not None:
        cargs.extend([
            "--fsgd",
            execution.input_file(params.get("fsgd"))
        ])
    if params.get("maxsegno") is not None:
        cargs.extend([
            "--maxsegno",
            *params.get("maxsegno")
        ])
    if params.get("segids_from_file") is not None:
        cargs.extend([
            "--segids-from-file",
            execution.input_file(params.get("segids_from_file"))
        ])
    if params.get("segno_include") is not None:
        cargs.extend([
            "--segno",
            *params.get("segno_include")
        ])
    if params.get("segno_exclude") is not None:
        cargs.extend([
            "--no-segno",
            *params.get("segno_exclude")
        ])
    if params.get("measure") is not None:
        cargs.extend([
            "--meas",
            params.get("measure")
        ])
    if params.get("delimiter") is not None:
        cargs.extend([
            "--delimiter",
            params.get("delimiter")
        ])
    if params.get("statsfile") is not None:
        cargs.extend([
            "--statsfile",
            params.get("statsfile")
        ])
    if params.get("subdir") is not None:
        cargs.extend([
            "--subdir",
            params.get("subdir")
        ])
    if params.get("scale") is not None:
        cargs.extend([
            "--scale",
            str(params.get("scale"))
        ])
    if params.get("write_etiv"):
        cargs.append("--etiv")
    if params.get("debug"):
        cargs.append("--debug")
    if params.get("transpose_flag"):
        cargs.append("--transpose")
    if params.get("common_segs_flag"):
        cargs.append("--common-segs")
    if params.get("all_segs_flag"):
        cargs.append("--all-segs")
    if params.get("no_vol_extras_flag"):
        cargs.append("--no-vol-extras")
    if params.get("skip_missing_flag"):
        cargs.append("--skip")
    if params.get("replace53_flag"):
        cargs.append("--replace53")
    return cargs


def asegstats2table_outputs(
    params: Asegstats2tableParameters,
    execution: Execution,
) -> Asegstats2tableOutputs:
    """
    Build outputs object containing output file paths and possibly stdout/stderr.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Outputs object.
    """
    ret = Asegstats2tableOutputs(
        root=execution.output_file("."),
        output_table=execution.output_file(params.get("tablefile")),
    )
    return ret


def asegstats2table_execute(
    params: Asegstats2tableParameters,
    execution: Execution,
) -> Asegstats2tableOutputs:
    """
    Converts a subcortical stats file created by recon-all and/or mri_segstats
    (e.g., aseg.stats) into a table.
    
    Author: FreeSurfer Developers
    
    URL: https://github.com/freesurfer/freesurfer
    
    Args:
        params: The parameters.
        execution: The execution object.
    Returns:
        NamedTuple of outputs (described in `Asegstats2tableOutputs`).
    """
    params = execution.params(params)
    cargs = asegstats2table_cargs(params, execution)
    ret = asegstats2table_outputs(params, execution)
    execution.run(cargs)
    return ret


def asegstats2table(
    tablefile: str,
    subjects: list[str] | None = None,
    inputs: list[str] | None = None,
    subjectsfile: InputPathType | None = None,
    qdec: InputPathType | None = None,
    qdec_long: InputPathType | None = None,
    fsgd: InputPathType | None = None,
    maxsegno: list[str] | None = None,
    segids_from_file: InputPathType | None = None,
    segno_include: list[str] | None = None,
    segno_exclude: list[str] | None = None,
    measure: str | None = None,
    delimiter: str | None = None,
    statsfile: str | None = None,
    subdir: str | None = None,
    scale: float | None = None,
    write_etiv: bool = False,
    debug: bool = False,
    transpose_flag: bool = False,
    common_segs_flag: bool = False,
    all_segs_flag: bool = False,
    no_vol_extras_flag: bool = False,
    skip_missing_flag: bool = False,
    replace53_flag: bool = False,
    runner: Runner | None = None,
) -> Asegstats2tableOutputs:
    """
    Converts a subcortical stats file created by recon-all and/or mri_segstats
    (e.g., aseg.stats) into a table.
    
    Author: FreeSurfer Developers
    
    URL: https://github.com/freesurfer/freesurfer
    
    Args:
        tablefile: The output table file.
        subjects: List of subjects.
        inputs: List of input stat files.
        subjectsfile: Name of the file which has the list of subjects (one\
            subject per line).
        qdec: Name of the qdec table which has the column of subjects ids\
            (fsid).
        qdec_long: Name of the longitudinal qdec table with column of tp ids\
            (fsid) and subject templates (fsid-base).
        fsgd: Name of the FSGD file to extract subjects from.
        maxsegno: Specify the maximum segmentation number.
        segids_from_file: Output only the segmentations present in the\
            specified file.
        segno_include: Include only the specified segmentation IDs.
        segno_exclude: Exclude the specified segmentation IDs.
        measure: Measure to report: default is volume (alternative: mean, std).
        delimiter: Delimiter between measures in the table. Default is tab\
            (alternative: comma, space, semicolon).
        statsfile: Use specified stats file instead of 'aseg.stats'.
        subdir: Use specified subdir instead of 'stats/'.
        scale: Scale factor for all values written to output file. Default is\
            1.
        write_etiv: Report volume as percent estimated total intracranial\
            volume.
        debug: Increase verbosity for debugging purposes.
        transpose_flag: Transpose the table: subjects in columns and\
            segmentations in rows.
        common_segs_flag: Output only the segmentations common to all stats\
            files.
        all_segs_flag: Output all segmentations in the stats files given.
        no_vol_extras_flag: Do not include global volume measures like\
            BrainSegVol.
        skip_missing_flag: Skip subjects that do not have a stats file.
        replace53_flag: Replace 5.3 structure names with later names.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `Asegstats2tableOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(ASEGSTATS2TABLE_METADATA)
    params = asegstats2table_params(
        subjects=subjects,
        inputs=inputs,
        tablefile=tablefile,
        subjectsfile=subjectsfile,
        qdec=qdec,
        qdec_long=qdec_long,
        fsgd=fsgd,
        maxsegno=maxsegno,
        segids_from_file=segids_from_file,
        segno_include=segno_include,
        segno_exclude=segno_exclude,
        measure=measure,
        delimiter=delimiter,
        statsfile=statsfile,
        subdir=subdir,
        scale=scale,
        write_etiv=write_etiv,
        debug=debug,
        transpose_flag=transpose_flag,
        common_segs_flag=common_segs_flag,
        all_segs_flag=all_segs_flag,
        no_vol_extras_flag=no_vol_extras_flag,
        skip_missing_flag=skip_missing_flag,
        replace53_flag=replace53_flag,
    )
    return asegstats2table_execute(params, execution)


__all__ = [
    "ASEGSTATS2TABLE_METADATA",
    "Asegstats2tableOutputs",
    "Asegstats2tableParameters",
    "asegstats2table",
    "asegstats2table_params",
]
