# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *

FIX_SUBJECT_CORRECTED_METADATA = Metadata(
    id="e9683c6b2300288726f90faacf8034788b095c6c.boutiques",
    name="fix_subject_corrected",
    package="freesurfer",
    container_image_tag="freesurfer/freesurfer:7.4.1",
)


FixSubjectCorrectedParameters = typing.TypedDict('FixSubjectCorrectedParameters', {
    "__STYXTYPE__": typing.Literal["fix_subject_corrected"],
    "subject_directory": str,
    "output_directory": str,
})


def dyn_cargs(
    t: str,
) -> typing.Any:
    """
    Get build cargs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build cargs function.
    """
    return {
        "fix_subject_corrected": fix_subject_corrected_cargs,
    }.get(t)


def dyn_outputs(
    t: str,
) -> typing.Any:
    """
    Get build outputs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build outputs function.
    """
    return {
    }.get(t)


class FixSubjectCorrectedOutputs(typing.NamedTuple):
    """
    Output object returned when calling `fix_subject_corrected(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""


def fix_subject_corrected_params(
    subject_directory: str,
    output_directory: str,
) -> FixSubjectCorrectedParameters:
    """
    Build parameters.
    
    Args:
        subject_directory: Path to the subject's directory.
        output_directory: Path to the output directory.
    Returns:
        Parameter dictionary
    """
    params = {
        "__STYXTYPE__": "fix_subject_corrected",
        "subject_directory": subject_directory,
        "output_directory": output_directory,
    }
    return params


def fix_subject_corrected_cargs(
    params: FixSubjectCorrectedParameters,
    execution: Execution,
) -> list[str]:
    """
    Build command-line arguments from parameters.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Command-line arguments.
    """
    cargs = []
    cargs.append("fix_subject_corrected")
    cargs.append(params.get("subject_directory"))
    cargs.append(params.get("output_directory"))
    return cargs


def fix_subject_corrected_outputs(
    params: FixSubjectCorrectedParameters,
    execution: Execution,
) -> FixSubjectCorrectedOutputs:
    """
    Build outputs object containing output file paths and possibly stdout/stderr.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Outputs object.
    """
    ret = FixSubjectCorrectedOutputs(
        root=execution.output_file("."),
    )
    return ret


def fix_subject_corrected_execute(
    params: FixSubjectCorrectedParameters,
    execution: Execution,
) -> FixSubjectCorrectedOutputs:
    """
    Corrects subject data in FreeSurfer.
    
    Author: FreeSurfer Developers
    
    URL: https://github.com/freesurfer/freesurfer
    
    Args:
        params: The parameters.
        execution: The execution object.
    Returns:
        NamedTuple of outputs (described in `FixSubjectCorrectedOutputs`).
    """
    params = execution.params(params)
    cargs = fix_subject_corrected_cargs(params, execution)
    ret = fix_subject_corrected_outputs(params, execution)
    execution.run(cargs)
    return ret


def fix_subject_corrected(
    subject_directory: str,
    output_directory: str,
    runner: Runner | None = None,
) -> FixSubjectCorrectedOutputs:
    """
    Corrects subject data in FreeSurfer.
    
    Author: FreeSurfer Developers
    
    URL: https://github.com/freesurfer/freesurfer
    
    Args:
        subject_directory: Path to the subject's directory.
        output_directory: Path to the output directory.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `FixSubjectCorrectedOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(FIX_SUBJECT_CORRECTED_METADATA)
    params = fix_subject_corrected_params(
        subject_directory=subject_directory,
        output_directory=output_directory,
    )
    return fix_subject_corrected_execute(params, execution)


__all__ = [
    "FIX_SUBJECT_CORRECTED_METADATA",
    "FixSubjectCorrectedOutputs",
    "FixSubjectCorrectedParameters",
    "fix_subject_corrected",
    "fix_subject_corrected_params",
]
