# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *

FS_TEMP_DIR_METADATA = Metadata(
    id="d9debad2d46dec10deffc0f2440d01543333ec6a.boutiques",
    name="fs_temp_dir",
    package="freesurfer",
    container_image_tag="freesurfer/freesurfer:7.4.1",
)


FsTempDirParameters = typing.TypedDict('FsTempDirParameters', {
    "__STYXTYPE__": typing.Literal["fs_temp_dir"],
    "base_directory": typing.NotRequired[str | None],
    "scratch": bool,
})


def dyn_cargs(
    t: str,
) -> typing.Any:
    """
    Get build cargs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build cargs function.
    """
    return {
        "fs_temp_dir": fs_temp_dir_cargs,
    }.get(t)


def dyn_outputs(
    t: str,
) -> typing.Any:
    """
    Get build outputs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build outputs function.
    """
    return {
        "fs_temp_dir": fs_temp_dir_outputs,
    }.get(t)


class FsTempDirOutputs(typing.NamedTuple):
    """
    Output object returned when calling `fs_temp_dir(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""
    output_directory: OutputPathType
    """The created temporary directory path"""


def fs_temp_dir_params(
    base_directory: str | None = None,
    scratch: bool = False,
) -> FsTempDirParameters:
    """
    Build parameters.
    
    Args:
        base_directory: Manually specify base temporary directory.
        scratch: Use /scratch directory if available, but FS_TMPDIR takes\
            priority.
    Returns:
        Parameter dictionary
    """
    params = {
        "__STYXTYPE__": "fs_temp_dir",
        "scratch": scratch,
    }
    if base_directory is not None:
        params["base_directory"] = base_directory
    return params


def fs_temp_dir_cargs(
    params: FsTempDirParameters,
    execution: Execution,
) -> list[str]:
    """
    Build command-line arguments from parameters.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Command-line arguments.
    """
    cargs = []
    cargs.append("fs_temp_dir")
    if params.get("base_directory") is not None:
        cargs.extend([
            "-b",
            params.get("base_directory")
        ])
    if params.get("scratch"):
        cargs.append("--scratch")
    return cargs


def fs_temp_dir_outputs(
    params: FsTempDirParameters,
    execution: Execution,
) -> FsTempDirOutputs:
    """
    Build outputs object containing output file paths and possibly stdout/stderr.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Outputs object.
    """
    ret = FsTempDirOutputs(
        root=execution.output_file("."),
        output_directory=execution.output_file("/tmp/tmp.SF5J66"),
    )
    return ret


def fs_temp_dir_execute(
    params: FsTempDirParameters,
    execution: Execution,
) -> FsTempDirOutputs:
    """
    Generates and creates an empty temporary directory.
    
    Author: FreeSurfer Developers
    
    URL: https://github.com/freesurfer/freesurfer
    
    Args:
        params: The parameters.
        execution: The execution object.
    Returns:
        NamedTuple of outputs (described in `FsTempDirOutputs`).
    """
    params = execution.params(params)
    cargs = fs_temp_dir_cargs(params, execution)
    ret = fs_temp_dir_outputs(params, execution)
    execution.run(cargs)
    return ret


def fs_temp_dir(
    base_directory: str | None = None,
    scratch: bool = False,
    runner: Runner | None = None,
) -> FsTempDirOutputs:
    """
    Generates and creates an empty temporary directory.
    
    Author: FreeSurfer Developers
    
    URL: https://github.com/freesurfer/freesurfer
    
    Args:
        base_directory: Manually specify base temporary directory.
        scratch: Use /scratch directory if available, but FS_TMPDIR takes\
            priority.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `FsTempDirOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(FS_TEMP_DIR_METADATA)
    params = fs_temp_dir_params(
        base_directory=base_directory,
        scratch=scratch,
    )
    return fs_temp_dir_execute(params, execution)


__all__ = [
    "FS_TEMP_DIR_METADATA",
    "FsTempDirOutputs",
    "FsTempDirParameters",
    "fs_temp_dir",
    "fs_temp_dir_params",
]
