# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *

MORPH_SUBJECT_LH_METADATA = Metadata(
    id="50281e785fbd08bfa132876681fac0d45cfa2be9.boutiques",
    name="morph_subject-lh",
    package="freesurfer",
    container_image_tag="freesurfer/freesurfer:7.4.1",
)


MorphSubjectLhParameters = typing.TypedDict('MorphSubjectLhParameters', {
    "__STYXTYPE__": typing.Literal["morph_subject-lh"],
    "subject_id": str,
})


def dyn_cargs(
    t: str,
) -> typing.Any:
    """
    Get build cargs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build cargs function.
    """
    return {
        "morph_subject-lh": morph_subject_lh_cargs,
    }.get(t)


def dyn_outputs(
    t: str,
) -> typing.Any:
    """
    Get build outputs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build outputs function.
    """
    return {
    }.get(t)


class MorphSubjectLhOutputs(typing.NamedTuple):
    """
    Output object returned when calling `morph_subject_lh(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""


def morph_subject_lh_params(
    subject_id: str,
) -> MorphSubjectLhParameters:
    """
    Build parameters.
    
    Args:
        subject_id: Subject ID.
    Returns:
        Parameter dictionary
    """
    params = {
        "__STYXTYPE__": "morph_subject-lh",
        "subject_id": subject_id,
    }
    return params


def morph_subject_lh_cargs(
    params: MorphSubjectLhParameters,
    execution: Execution,
) -> list[str]:
    """
    Build command-line arguments from parameters.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Command-line arguments.
    """
    cargs = []
    cargs.append("morph_subject-lh")
    cargs.extend([
        "-lh",
        params.get("subject_id")
    ])
    return cargs


def morph_subject_lh_outputs(
    params: MorphSubjectLhParameters,
    execution: Execution,
) -> MorphSubjectLhOutputs:
    """
    Build outputs object containing output file paths and possibly stdout/stderr.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Outputs object.
    """
    ret = MorphSubjectLhOutputs(
        root=execution.output_file("."),
    )
    return ret


def morph_subject_lh_execute(
    params: MorphSubjectLhParameters,
    execution: Execution,
) -> MorphSubjectLhOutputs:
    """
    A tool for morphing subject's left hemisphere.
    
    Author: FreeSurfer Developers
    
    URL: https://github.com/freesurfer/freesurfer
    
    Args:
        params: The parameters.
        execution: The execution object.
    Returns:
        NamedTuple of outputs (described in `MorphSubjectLhOutputs`).
    """
    params = execution.params(params)
    cargs = morph_subject_lh_cargs(params, execution)
    ret = morph_subject_lh_outputs(params, execution)
    execution.run(cargs)
    return ret


def morph_subject_lh(
    subject_id: str,
    runner: Runner | None = None,
) -> MorphSubjectLhOutputs:
    """
    A tool for morphing subject's left hemisphere.
    
    Author: FreeSurfer Developers
    
    URL: https://github.com/freesurfer/freesurfer
    
    Args:
        subject_id: Subject ID.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `MorphSubjectLhOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(MORPH_SUBJECT_LH_METADATA)
    params = morph_subject_lh_params(
        subject_id=subject_id,
    )
    return morph_subject_lh_execute(params, execution)


__all__ = [
    "MORPH_SUBJECT_LH_METADATA",
    "MorphSubjectLhOutputs",
    "MorphSubjectLhParameters",
    "morph_subject_lh",
    "morph_subject_lh_params",
]
