# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *

MRI_DCT_ALIGN_METADATA = Metadata(
    id="41e6e579d5ddb08e54325cc779dff53fb8fda430.boutiques",
    name="mri_dct_align",
    package="freesurfer",
    container_image_tag="freesurfer/freesurfer:7.4.1",
)


MriDctAlignParameters = typing.TypedDict('MriDctAlignParameters', {
    "__STYXTYPE__": typing.Literal["mri_dct_align"],
    "source": InputPathType,
    "destination": InputPathType,
    "output_xform": str,
})


def dyn_cargs(
    t: str,
) -> typing.Any:
    """
    Get build cargs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build cargs function.
    """
    return {
        "mri_dct_align": mri_dct_align_cargs,
    }.get(t)


def dyn_outputs(
    t: str,
) -> typing.Any:
    """
    Get build outputs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build outputs function.
    """
    return {
        "mri_dct_align": mri_dct_align_outputs,
    }.get(t)


class MriDctAlignOutputs(typing.NamedTuple):
    """
    Output object returned when calling `mri_dct_align(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""
    output_xform_file: OutputPathType
    """Transformation file resulting from the alignment"""


def mri_dct_align_params(
    source: InputPathType,
    destination: InputPathType,
    output_xform: str,
) -> MriDctAlignParameters:
    """
    Build parameters.
    
    Args:
        source: Source image file.
        destination: Destination image file.
        output_xform: Output transformation file.
    Returns:
        Parameter dictionary
    """
    params = {
        "__STYXTYPE__": "mri_dct_align",
        "source": source,
        "destination": destination,
        "output_xform": output_xform,
    }
    return params


def mri_dct_align_cargs(
    params: MriDctAlignParameters,
    execution: Execution,
) -> list[str]:
    """
    Build command-line arguments from parameters.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Command-line arguments.
    """
    cargs = []
    cargs.append("mri_dct_align")
    cargs.append(execution.input_file(params.get("source")))
    cargs.append(execution.input_file(params.get("destination")))
    cargs.append(params.get("output_xform"))
    return cargs


def mri_dct_align_outputs(
    params: MriDctAlignParameters,
    execution: Execution,
) -> MriDctAlignOutputs:
    """
    Build outputs object containing output file paths and possibly stdout/stderr.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Outputs object.
    """
    ret = MriDctAlignOutputs(
        root=execution.output_file("."),
        output_xform_file=execution.output_file(params.get("output_xform")),
    )
    return ret


def mri_dct_align_execute(
    params: MriDctAlignParameters,
    execution: Execution,
) -> MriDctAlignOutputs:
    """
    MRI DCT alignment tool from FreeSurfer.
    
    Author: FreeSurfer Developers
    
    URL: https://github.com/freesurfer/freesurfer
    
    Args:
        params: The parameters.
        execution: The execution object.
    Returns:
        NamedTuple of outputs (described in `MriDctAlignOutputs`).
    """
    params = execution.params(params)
    cargs = mri_dct_align_cargs(params, execution)
    ret = mri_dct_align_outputs(params, execution)
    execution.run(cargs)
    return ret


def mri_dct_align(
    source: InputPathType,
    destination: InputPathType,
    output_xform: str,
    runner: Runner | None = None,
) -> MriDctAlignOutputs:
    """
    MRI DCT alignment tool from FreeSurfer.
    
    Author: FreeSurfer Developers
    
    URL: https://github.com/freesurfer/freesurfer
    
    Args:
        source: Source image file.
        destination: Destination image file.
        output_xform: Output transformation file.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `MriDctAlignOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(MRI_DCT_ALIGN_METADATA)
    params = mri_dct_align_params(
        source=source,
        destination=destination,
        output_xform=output_xform,
    )
    return mri_dct_align_execute(params, execution)


__all__ = [
    "MRI_DCT_ALIGN_METADATA",
    "MriDctAlignOutputs",
    "MriDctAlignParameters",
    "mri_dct_align",
    "mri_dct_align_params",
]
