# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *

MRI_MOTION_CORRECT2_METADATA = Metadata(
    id="fe7d6aa6909c6c6427395fe290915359fd71bc6d.boutiques",
    name="mri_motion_correct2",
    package="freesurfer",
    container_image_tag="freesurfer/freesurfer:7.4.1",
)


MriMotionCorrect2Parameters = typing.TypedDict('MriMotionCorrect2Parameters', {
    "__STYXTYPE__": typing.Literal["mri_motion_correct2"],
    "output_spec": str,
    "input_files": list[InputPathType],
    "target": typing.NotRequired[InputPathType | None],
    "wild": bool,
    "tmp_dir": typing.NotRequired[str | None],
    "nocleanup": bool,
    "umask": typing.NotRequired[str | None],
    "cm": bool,
    "version": bool,
    "debug": bool,
})


def dyn_cargs(
    t: str,
) -> typing.Any:
    """
    Get build cargs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build cargs function.
    """
    return {
        "mri_motion_correct2": mri_motion_correct2_cargs,
    }.get(t)


def dyn_outputs(
    t: str,
) -> typing.Any:
    """
    Get build outputs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build outputs function.
    """
    return {
        "mri_motion_correct2": mri_motion_correct2_outputs,
    }.get(t)


class MriMotionCorrect2Outputs(typing.NamedTuple):
    """
    Output object returned when calling `mri_motion_correct2(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""
    output_file: OutputPathType
    """The aligned and averaged output file or directory"""


def mri_motion_correct2_params(
    output_spec: str,
    input_files: list[InputPathType],
    target: InputPathType | None = None,
    wild: bool = False,
    tmp_dir: str | None = None,
    nocleanup: bool = False,
    umask: str | None = None,
    cm: bool = False,
    version: bool = False,
    debug: bool = False,
) -> MriMotionCorrect2Parameters:
    """
    Build parameters.
    
    Args:
        output_spec: Output file or directory (for COR format).
        input_files: Input volume files, specified multiple times for multiple\
            files.
        target: Use the specified target instead of the first input file.
        wild: Assume unmatched arguments are input files.
        tmp_dir: Directory for temporary files.
        nocleanup: Do not delete temporary files.
        umask: Set UNIX file permission mask.
        cm: Make COR volumes conform to minimum voxel size.
        version: Print version information and exit.
        debug: Print detailed debug information to screen.
    Returns:
        Parameter dictionary
    """
    params = {
        "__STYXTYPE__": "mri_motion_correct2",
        "output_spec": output_spec,
        "input_files": input_files,
        "wild": wild,
        "nocleanup": nocleanup,
        "cm": cm,
        "version": version,
        "debug": debug,
    }
    if target is not None:
        params["target"] = target
    if tmp_dir is not None:
        params["tmp_dir"] = tmp_dir
    if umask is not None:
        params["umask"] = umask
    return params


def mri_motion_correct2_cargs(
    params: MriMotionCorrect2Parameters,
    execution: Execution,
) -> list[str]:
    """
    Build command-line arguments from parameters.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Command-line arguments.
    """
    cargs = []
    cargs.append("mri_motion_correct2")
    cargs.extend([
        "-o",
        params.get("output_spec")
    ])
    cargs.extend([
        "-i",
        *[execution.input_file(f) for f in params.get("input_files")]
    ])
    if params.get("target") is not None:
        cargs.extend([
            "-t",
            execution.input_file(params.get("target"))
        ])
    if params.get("wild"):
        cargs.append("-wild")
    if params.get("tmp_dir") is not None:
        cargs.extend([
            "-tmpdir",
            params.get("tmp_dir")
        ])
    if params.get("nocleanup"):
        cargs.append("-nocleanup")
    if params.get("umask") is not None:
        cargs.extend([
            "-umask",
            params.get("umask")
        ])
    if params.get("cm"):
        cargs.append("-cm")
    if params.get("version"):
        cargs.append("-version")
    if params.get("debug"):
        cargs.append("-debug")
    return cargs


def mri_motion_correct2_outputs(
    params: MriMotionCorrect2Parameters,
    execution: Execution,
) -> MriMotionCorrect2Outputs:
    """
    Build outputs object containing output file paths and possibly stdout/stderr.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Outputs object.
    """
    ret = MriMotionCorrect2Outputs(
        root=execution.output_file("."),
        output_file=execution.output_file(params.get("output_spec")),
    )
    return ret


def mri_motion_correct2_execute(
    params: MriMotionCorrect2Parameters,
    execution: Execution,
) -> MriMotionCorrect2Outputs:
    """
    Aligns and averages two or more volumes using minctracc for alignment and
    mincresample and mincaverage for resampling.
    
    Author: FreeSurfer Developers
    
    URL: https://github.com/freesurfer/freesurfer
    
    Args:
        params: The parameters.
        execution: The execution object.
    Returns:
        NamedTuple of outputs (described in `MriMotionCorrect2Outputs`).
    """
    params = execution.params(params)
    cargs = mri_motion_correct2_cargs(params, execution)
    ret = mri_motion_correct2_outputs(params, execution)
    execution.run(cargs)
    return ret


def mri_motion_correct2(
    output_spec: str,
    input_files: list[InputPathType],
    target: InputPathType | None = None,
    wild: bool = False,
    tmp_dir: str | None = None,
    nocleanup: bool = False,
    umask: str | None = None,
    cm: bool = False,
    version: bool = False,
    debug: bool = False,
    runner: Runner | None = None,
) -> MriMotionCorrect2Outputs:
    """
    Aligns and averages two or more volumes using minctracc for alignment and
    mincresample and mincaverage for resampling.
    
    Author: FreeSurfer Developers
    
    URL: https://github.com/freesurfer/freesurfer
    
    Args:
        output_spec: Output file or directory (for COR format).
        input_files: Input volume files, specified multiple times for multiple\
            files.
        target: Use the specified target instead of the first input file.
        wild: Assume unmatched arguments are input files.
        tmp_dir: Directory for temporary files.
        nocleanup: Do not delete temporary files.
        umask: Set UNIX file permission mask.
        cm: Make COR volumes conform to minimum voxel size.
        version: Print version information and exit.
        debug: Print detailed debug information to screen.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `MriMotionCorrect2Outputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(MRI_MOTION_CORRECT2_METADATA)
    params = mri_motion_correct2_params(
        output_spec=output_spec,
        input_files=input_files,
        target=target,
        wild=wild,
        tmp_dir=tmp_dir,
        nocleanup=nocleanup,
        umask=umask,
        cm=cm,
        version=version,
        debug=debug,
    )
    return mri_motion_correct2_execute(params, execution)


__all__ = [
    "MRI_MOTION_CORRECT2_METADATA",
    "MriMotionCorrect2Outputs",
    "MriMotionCorrect2Parameters",
    "mri_motion_correct2",
    "mri_motion_correct2_params",
]
