# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *

PRINT_UNIQUE_LABELS_CSH_METADATA = Metadata(
    id="5dca4f4c348d9237bae9336374cad3ee2174c9c8.boutiques",
    name="print_unique_labels.csh",
    package="freesurfer",
    container_image_tag="freesurfer/freesurfer:7.4.1",
)


PrintUniqueLabelsCshParameters = typing.TypedDict('PrintUniqueLabelsCshParameters', {
    "__STYXTYPE__": typing.Literal["print_unique_labels.csh"],
    "label_volume": InputPathType,
    "output_file": typing.NotRequired[str | None],
    "list_only": bool,
    "version": bool,
    "help": bool,
})


def dyn_cargs(
    t: str,
) -> typing.Any:
    """
    Get build cargs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build cargs function.
    """
    return {
        "print_unique_labels.csh": print_unique_labels_csh_cargs,
    }.get(t)


def dyn_outputs(
    t: str,
) -> typing.Any:
    """
    Get build outputs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build outputs function.
    """
    return {
        "print_unique_labels.csh": print_unique_labels_csh_outputs,
    }.get(t)


class PrintUniqueLabelsCshOutputs(typing.NamedTuple):
    """
    Output object returned when calling `print_unique_labels_csh(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""
    results_file: OutputPathType | None
    """Output file with the list of unique labels"""


def print_unique_labels_csh_params(
    label_volume: InputPathType,
    output_file: str | None = None,
    list_only: bool = False,
    version: bool = False,
    help_: bool = False,
) -> PrintUniqueLabelsCshParameters:
    """
    Build parameters.
    
    Args:
        label_volume: Label volume to be analyzed.
        output_file: Text file where the results are written.
        list_only: Only list the labels.
        version: Print version and exit.
        help_: Print help and exit.
    Returns:
        Parameter dictionary
    """
    params = {
        "__STYXTYPE__": "print_unique_labels.csh",
        "label_volume": label_volume,
        "list_only": list_only,
        "version": version,
        "help": help_,
    }
    if output_file is not None:
        params["output_file"] = output_file
    return params


def print_unique_labels_csh_cargs(
    params: PrintUniqueLabelsCshParameters,
    execution: Execution,
) -> list[str]:
    """
    Build command-line arguments from parameters.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Command-line arguments.
    """
    cargs = []
    cargs.append("print_unique_labels.csh")
    cargs.extend([
        "--vol",
        execution.input_file(params.get("label_volume"))
    ])
    if params.get("output_file") is not None:
        cargs.extend([
            "--out",
            params.get("output_file")
        ])
    if params.get("list_only"):
        cargs.append("--list")
    if params.get("version"):
        cargs.append("--version")
    if params.get("help"):
        cargs.append("--help")
    return cargs


def print_unique_labels_csh_outputs(
    params: PrintUniqueLabelsCshParameters,
    execution: Execution,
) -> PrintUniqueLabelsCshOutputs:
    """
    Build outputs object containing output file paths and possibly stdout/stderr.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Outputs object.
    """
    ret = PrintUniqueLabelsCshOutputs(
        root=execution.output_file("."),
        results_file=execution.output_file(params.get("output_file")) if (params.get("output_file") is not None) else None,
    )
    return ret


def print_unique_labels_csh_execute(
    params: PrintUniqueLabelsCshParameters,
    execution: Execution,
) -> PrintUniqueLabelsCshOutputs:
    """
    Prints the list of unique labels (with structure name) in the input volume.
    
    Author: FreeSurfer Developers
    
    URL: https://github.com/freesurfer/freesurfer
    
    Args:
        params: The parameters.
        execution: The execution object.
    Returns:
        NamedTuple of outputs (described in `PrintUniqueLabelsCshOutputs`).
    """
    params = execution.params(params)
    cargs = print_unique_labels_csh_cargs(params, execution)
    ret = print_unique_labels_csh_outputs(params, execution)
    execution.run(cargs)
    return ret


def print_unique_labels_csh(
    label_volume: InputPathType,
    output_file: str | None = None,
    list_only: bool = False,
    version: bool = False,
    help_: bool = False,
    runner: Runner | None = None,
) -> PrintUniqueLabelsCshOutputs:
    """
    Prints the list of unique labels (with structure name) in the input volume.
    
    Author: FreeSurfer Developers
    
    URL: https://github.com/freesurfer/freesurfer
    
    Args:
        label_volume: Label volume to be analyzed.
        output_file: Text file where the results are written.
        list_only: Only list the labels.
        version: Print version and exit.
        help_: Print help and exit.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `PrintUniqueLabelsCshOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(PRINT_UNIQUE_LABELS_CSH_METADATA)
    params = print_unique_labels_csh_params(
        label_volume=label_volume,
        output_file=output_file,
        list_only=list_only,
        version=version,
        help_=help_,
    )
    return print_unique_labels_csh_execute(params, execution)


__all__ = [
    "PRINT_UNIQUE_LABELS_CSH_METADATA",
    "PrintUniqueLabelsCshOutputs",
    "PrintUniqueLabelsCshParameters",
    "print_unique_labels_csh",
    "print_unique_labels_csh_params",
]
