# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *

RUN_SEGMENT_SUBJECT_T2_AUTO_ESTIMATE_ALVEUS_ML_SH_METADATA = Metadata(
    id="2a8c1490dc550d5a8ebdcd5a722be9a6d0cb534c.boutiques",
    name="run_segmentSubjectT2_autoEstimateAlveusML.sh",
    package="freesurfer",
    container_image_tag="freesurfer/freesurfer:7.4.1",
)


RunSegmentSubjectT2AutoEstimateAlveusMlShParameters = typing.TypedDict('RunSegmentSubjectT2AutoEstimateAlveusMlShParameters', {
    "__STYXTYPE__": typing.Literal["run_segmentSubjectT2_autoEstimateAlveusML.sh"],
    "deployed_mcr_root": str,
    "arguments": typing.NotRequired[list[str] | None],
})


def dyn_cargs(
    t: str,
) -> typing.Any:
    """
    Get build cargs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build cargs function.
    """
    return {
        "run_segmentSubjectT2_autoEstimateAlveusML.sh": run_segment_subject_t2_auto_estimate_alveus_ml_sh_cargs,
    }.get(t)


def dyn_outputs(
    t: str,
) -> typing.Any:
    """
    Get build outputs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build outputs function.
    """
    return {
    }.get(t)


class RunSegmentSubjectT2AutoEstimateAlveusMlShOutputs(typing.NamedTuple):
    """
    Output object returned when calling `run_segment_subject_t2_auto_estimate_alveus_ml_sh(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""


def run_segment_subject_t2_auto_estimate_alveus_ml_sh_params(
    deployed_mcr_root: str,
    arguments: list[str] | None = None,
) -> RunSegmentSubjectT2AutoEstimateAlveusMlShParameters:
    """
    Build parameters.
    
    Args:
        deployed_mcr_root: Path to the deployed MATLAB Compiler Runtime (MCR)\
            root directory.
        arguments: Arguments for segmenting subject T2 and automatically\
            estimating Alveus using Machine Learning.
    Returns:
        Parameter dictionary
    """
    params = {
        "__STYXTYPE__": "run_segmentSubjectT2_autoEstimateAlveusML.sh",
        "deployed_mcr_root": deployed_mcr_root,
    }
    if arguments is not None:
        params["arguments"] = arguments
    return params


def run_segment_subject_t2_auto_estimate_alveus_ml_sh_cargs(
    params: RunSegmentSubjectT2AutoEstimateAlveusMlShParameters,
    execution: Execution,
) -> list[str]:
    """
    Build command-line arguments from parameters.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Command-line arguments.
    """
    cargs = []
    cargs.append("run_segmentSubjectT2_autoEstimateAlveusML.sh")
    cargs.append(params.get("deployed_mcr_root"))
    if params.get("arguments") is not None:
        cargs.extend(params.get("arguments"))
    return cargs


def run_segment_subject_t2_auto_estimate_alveus_ml_sh_outputs(
    params: RunSegmentSubjectT2AutoEstimateAlveusMlShParameters,
    execution: Execution,
) -> RunSegmentSubjectT2AutoEstimateAlveusMlShOutputs:
    """
    Build outputs object containing output file paths and possibly stdout/stderr.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Outputs object.
    """
    ret = RunSegmentSubjectT2AutoEstimateAlveusMlShOutputs(
        root=execution.output_file("."),
    )
    return ret


def run_segment_subject_t2_auto_estimate_alveus_ml_sh_execute(
    params: RunSegmentSubjectT2AutoEstimateAlveusMlShParameters,
    execution: Execution,
) -> RunSegmentSubjectT2AutoEstimateAlveusMlShOutputs:
    """
    Script to run segmentSubjectT2_autoEstimateAlveusML operation. This script
    requires a MATLAB Compiler Runtime (MCR) root directory as input, but help
    output indicates missing library reference for operation.
    
    Author: FreeSurfer Developers
    
    URL: https://github.com/freesurfer/freesurfer
    
    Args:
        params: The parameters.
        execution: The execution object.
    Returns:
        NamedTuple of outputs (described in `RunSegmentSubjectT2AutoEstimateAlveusMlShOutputs`).
    """
    params = execution.params(params)
    cargs = run_segment_subject_t2_auto_estimate_alveus_ml_sh_cargs(params, execution)
    ret = run_segment_subject_t2_auto_estimate_alveus_ml_sh_outputs(params, execution)
    execution.run(cargs)
    return ret


def run_segment_subject_t2_auto_estimate_alveus_ml_sh(
    deployed_mcr_root: str,
    arguments: list[str] | None = None,
    runner: Runner | None = None,
) -> RunSegmentSubjectT2AutoEstimateAlveusMlShOutputs:
    """
    Script to run segmentSubjectT2_autoEstimateAlveusML operation. This script
    requires a MATLAB Compiler Runtime (MCR) root directory as input, but help
    output indicates missing library reference for operation.
    
    Author: FreeSurfer Developers
    
    URL: https://github.com/freesurfer/freesurfer
    
    Args:
        deployed_mcr_root: Path to the deployed MATLAB Compiler Runtime (MCR)\
            root directory.
        arguments: Arguments for segmenting subject T2 and automatically\
            estimating Alveus using Machine Learning.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `RunSegmentSubjectT2AutoEstimateAlveusMlShOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(RUN_SEGMENT_SUBJECT_T2_AUTO_ESTIMATE_ALVEUS_ML_SH_METADATA)
    params = run_segment_subject_t2_auto_estimate_alveus_ml_sh_params(
        deployed_mcr_root=deployed_mcr_root,
        arguments=arguments,
    )
    return run_segment_subject_t2_auto_estimate_alveus_ml_sh_execute(params, execution)


__all__ = [
    "RUN_SEGMENT_SUBJECT_T2_AUTO_ESTIMATE_ALVEUS_ML_SH_METADATA",
    "RunSegmentSubjectT2AutoEstimateAlveusMlShOutputs",
    "RunSegmentSubjectT2AutoEstimateAlveusMlShParameters",
    "run_segment_subject_t2_auto_estimate_alveus_ml_sh",
    "run_segment_subject_t2_auto_estimate_alveus_ml_sh_params",
]
