# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *

SEGMENT_THALAMIC_NUCLEI_SH_METADATA = Metadata(
    id="69ea92310c993122b1f5d2cde1689310a297d670.boutiques",
    name="segmentThalamicNuclei.sh",
    package="freesurfer",
    container_image_tag="freesurfer/freesurfer:7.4.1",
)


SegmentThalamicNucleiShParameters = typing.TypedDict('SegmentThalamicNucleiShParameters', {
    "__STYXTYPE__": typing.Literal["segmentThalamicNuclei.sh"],
    "subject_id": str,
    "output_dir": str,
})


def dyn_cargs(
    t: str,
) -> typing.Any:
    """
    Get build cargs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build cargs function.
    """
    return {
        "segmentThalamicNuclei.sh": segment_thalamic_nuclei_sh_cargs,
    }.get(t)


def dyn_outputs(
    t: str,
) -> typing.Any:
    """
    Get build outputs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build outputs function.
    """
    return {
        "segmentThalamicNuclei.sh": segment_thalamic_nuclei_sh_outputs,
    }.get(t)


class SegmentThalamicNucleiShOutputs(typing.NamedTuple):
    """
    Output object returned when calling `segment_thalamic_nuclei_sh(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""
    thalamic_nuclei_output: OutputPathType
    """Segmented thalamic nuclei output file"""


def segment_thalamic_nuclei_sh_params(
    subject_id: str,
    output_dir: str,
) -> SegmentThalamicNucleiShParameters:
    """
    Build parameters.
    
    Args:
        subject_id: Subject ID for segmentation.
        output_dir: Output directory for the segmented thalamic nuclei.
    Returns:
        Parameter dictionary
    """
    params = {
        "__STYXTYPE__": "segmentThalamicNuclei.sh",
        "subject_id": subject_id,
        "output_dir": output_dir,
    }
    return params


def segment_thalamic_nuclei_sh_cargs(
    params: SegmentThalamicNucleiShParameters,
    execution: Execution,
) -> list[str]:
    """
    Build command-line arguments from parameters.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Command-line arguments.
    """
    cargs = []
    cargs.append("segmentThalamicNuclei.sh")
    cargs.append(params.get("subject_id"))
    cargs.append(params.get("output_dir"))
    return cargs


def segment_thalamic_nuclei_sh_outputs(
    params: SegmentThalamicNucleiShParameters,
    execution: Execution,
) -> SegmentThalamicNucleiShOutputs:
    """
    Build outputs object containing output file paths and possibly stdout/stderr.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Outputs object.
    """
    ret = SegmentThalamicNucleiShOutputs(
        root=execution.output_file("."),
        thalamic_nuclei_output=execution.output_file(params.get("output_dir") + "/" + params.get("subject_id") + "_thalamic_nuclei.mgz"),
    )
    return ret


def segment_thalamic_nuclei_sh_execute(
    params: SegmentThalamicNucleiShParameters,
    execution: Execution,
) -> SegmentThalamicNucleiShOutputs:
    """
    Segment the thalamic nuclei using FreeSurfer.
    
    Author: FreeSurfer Developers
    
    URL: https://github.com/freesurfer/freesurfer
    
    Args:
        params: The parameters.
        execution: The execution object.
    Returns:
        NamedTuple of outputs (described in `SegmentThalamicNucleiShOutputs`).
    """
    params = execution.params(params)
    cargs = segment_thalamic_nuclei_sh_cargs(params, execution)
    ret = segment_thalamic_nuclei_sh_outputs(params, execution)
    execution.run(cargs)
    return ret


def segment_thalamic_nuclei_sh(
    subject_id: str,
    output_dir: str,
    runner: Runner | None = None,
) -> SegmentThalamicNucleiShOutputs:
    """
    Segment the thalamic nuclei using FreeSurfer.
    
    Author: FreeSurfer Developers
    
    URL: https://github.com/freesurfer/freesurfer
    
    Args:
        subject_id: Subject ID for segmentation.
        output_dir: Output directory for the segmented thalamic nuclei.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `SegmentThalamicNucleiShOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(SEGMENT_THALAMIC_NUCLEI_SH_METADATA)
    params = segment_thalamic_nuclei_sh_params(
        subject_id=subject_id,
        output_dir=output_dir,
    )
    return segment_thalamic_nuclei_sh_execute(params, execution)


__all__ = [
    "SEGMENT_THALAMIC_NUCLEI_SH_METADATA",
    "SegmentThalamicNucleiShOutputs",
    "SegmentThalamicNucleiShParameters",
    "segment_thalamic_nuclei_sh",
    "segment_thalamic_nuclei_sh_params",
]
