# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *

UNPACKIMADIR2_METADATA = Metadata(
    id="bdf6eb9c77635e9326080586e7654d60496c26b4.boutiques",
    name="unpackimadir2",
    package="freesurfer",
    container_image_tag="freesurfer/freesurfer:7.4.1",
)


Unpackimadir2Parameters = typing.TypedDict('Unpackimadir2Parameters', {
    "__STYXTYPE__": typing.Literal["unpackimadir2"],
    "directory": InputPathType,
})


def dyn_cargs(
    t: str,
) -> typing.Any:
    """
    Get build cargs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build cargs function.
    """
    return {
        "unpackimadir2": unpackimadir2_cargs,
    }.get(t)


def dyn_outputs(
    t: str,
) -> typing.Any:
    """
    Get build outputs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build outputs function.
    """
    return {
    }.get(t)


class Unpackimadir2Outputs(typing.NamedTuple):
    """
    Output object returned when calling `unpackimadir2(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""


def unpackimadir2_params(
    directory: InputPathType,
) -> Unpackimadir2Parameters:
    """
    Build parameters.
    
    Args:
        directory: Image directory to unpack.
    Returns:
        Parameter dictionary
    """
    params = {
        "__STYXTYPE__": "unpackimadir2",
        "directory": directory,
    }
    return params


def unpackimadir2_cargs(
    params: Unpackimadir2Parameters,
    execution: Execution,
) -> list[str]:
    """
    Build command-line arguments from parameters.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Command-line arguments.
    """
    cargs = []
    cargs.append("unpackimadir2")
    cargs.append(execution.input_file(params.get("directory")))
    return cargs


def unpackimadir2_outputs(
    params: Unpackimadir2Parameters,
    execution: Execution,
) -> Unpackimadir2Outputs:
    """
    Build outputs object containing output file paths and possibly stdout/stderr.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Outputs object.
    """
    ret = Unpackimadir2Outputs(
        root=execution.output_file("."),
    )
    return ret


def unpackimadir2_execute(
    params: Unpackimadir2Parameters,
    execution: Execution,
) -> Unpackimadir2Outputs:
    """
    Tool to unpack image directories, from FreeSurfer suite.
    
    Author: FreeSurfer Developers
    
    URL: https://github.com/freesurfer/freesurfer
    
    Args:
        params: The parameters.
        execution: The execution object.
    Returns:
        NamedTuple of outputs (described in `Unpackimadir2Outputs`).
    """
    params = execution.params(params)
    cargs = unpackimadir2_cargs(params, execution)
    ret = unpackimadir2_outputs(params, execution)
    execution.run(cargs)
    return ret


def unpackimadir2(
    directory: InputPathType,
    runner: Runner | None = None,
) -> Unpackimadir2Outputs:
    """
    Tool to unpack image directories, from FreeSurfer suite.
    
    Author: FreeSurfer Developers
    
    URL: https://github.com/freesurfer/freesurfer
    
    Args:
        directory: Image directory to unpack.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `Unpackimadir2Outputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(UNPACKIMADIR2_METADATA)
    params = unpackimadir2_params(
        directory=directory,
    )
    return unpackimadir2_execute(params, execution)


__all__ = [
    "UNPACKIMADIR2_METADATA",
    "Unpackimadir2Outputs",
    "Unpackimadir2Parameters",
    "unpackimadir2",
    "unpackimadir2_params",
]
